Index: /trunk/src/sys/arch/pmax/pmax/dec_5100.c
===================================================================
--- /trunk/src/sys/arch/pmax/pmax/dec_5100.c	(revision 151)
+++ /trunk/src/sys/arch/pmax/pmax/dec_5100.c	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: dec_5100.c,v 1.40 2007/12/03 15:34:10 ad Exp $ */
+/* $NetBSD: dec_5100.c,v 1.40.36.2 2010/12/29 00:20:37 matt Exp $ */
 
 /*
@@ -32,13 +32,15 @@
 #include <sys/cdefs.h>			/* RCS ID & Copyright macro defns */
 
-__KERNEL_RCSID(0, "$NetBSD: dec_5100.c,v 1.40 2007/12/03 15:34:10 ad Exp $");
-
+__KERNEL_RCSID(0, "$NetBSD: dec_5100.c,v 1.40.36.2 2010/12/29 00:20:37 matt Exp $");
+
+#define __INTR_PRIVATE
 #include <sys/param.h>
 #include <sys/systm.h>
 #include <sys/device.h>
+#include <sys/cpu.h>
+#include <sys/intr.h>
+#include <sys/lwp.h>
 #include <sys/kernel.h>
 
-#include <machine/cpu.h>
-#include <machine/intr.h>
 #include <machine/locore.h>
 #include <machine/sysconf.h>
@@ -56,19 +58,22 @@
 #include <pmax/pmax/cons.h>
 
-void		dec_5100_init __P((void));		/* XXX */
-static void	dec_5100_bus_reset __P((void));
-static void	dec_5100_cons_init __P((void));
-static void	dec_5100_intr __P((unsigned, unsigned, unsigned, unsigned));
-static void	dec_5100_intr_establish __P((struct device *, void *,
-		    int, int (*)(void *), void *));
-static void	dec_5100_memintr __P((void));
-
-static const int dec_5100_ipl2spl_table[] = {
+void		dec_5100_init(void);		/* XXX */
+static void	dec_5100_bus_reset(void);
+static void	dec_5100_cons_init(void);
+static void	dec_5100_intr(uint32_t, vaddr_t, uint32_t);
+static void	dec_5100_intr_establish(struct device *, void *,
+		    int, int (*)(void *), void *);
+static void	dec_5100_memintr(void);
+
+static const struct ipl_sr_map dec_5100_ipl_sr_map = {
+    .sr_bits = {
 	[IPL_NONE] = 0,
-	[IPL_SOFTCLOCK] = _SPL_SOFTCLOCK,
-	[IPL_SOFTNET] = _SPL_SOFTNET,
+	[IPL_SOFTCLOCK] = MIPS_SOFT_INT_MASK_0,
+	[IPL_SOFTNET] = MIPS_SOFT_INT_MASK,
 	[IPL_VM] = MIPS_SPL_0_1,
-	[IPL_SCHED] = MIPS_SPL_0_1_2,
-	[IPL_HIGH] = MIPS_SPL_0_1_2,
+	[IPL_SCHED] = MIPS_SPLHIGH,
+	[IPL_DDB] = MIPS_SPLHIGH,
+	[IPL_HIGH] = MIPS_SPLHIGH,
+    },
 };
 
@@ -87,5 +92,5 @@
 	mips_set_wbflush(kn230_wbflush);
 
-	ipl2spl_table = dec_5100_ipl2spl_table;
+	ipl_sr_map = dec_5100_ipl_sr_map;
 
 	/* calibrate cpu_mhz value */
@@ -101,10 +106,10 @@
 dec_5100_bus_reset()
 {
-	u_int32_t icsr;
+	uint32_t icsr;
 
 	/* clear any memory error condition */
-	icsr = *(volatile u_int32_t *)MIPS_PHYS_TO_KSEG1(KN230_SYS_ICSR);
+	icsr = *(volatile uint32_t *)MIPS_PHYS_TO_KSEG1(KN230_SYS_ICSR);
 	icsr |= KN230_CSR_INTR_WMERR;
-	*(volatile u_int32_t *)MIPS_PHYS_TO_KSEG1(KN230_SYS_ICSR) = icsr;
+	*(volatile uint32_t *)MIPS_PHYS_TO_KSEG1(KN230_SYS_ICSR) = icsr;
 
 	/* nothing else to do */
@@ -127,10 +132,6 @@
 
 static void
-dec_5100_intr_establish(dev, cookie, level, handler, arg)
-	struct device *dev;
-	void *cookie;
-	int level;
-	int (*handler) __P((void *));
-	void *arg;
+dec_5100_intr_establish(device_t dev, void *cookie, int level,
+	int (*handler)(void *), void *arg)
 {
 
@@ -149,11 +150,7 @@
 
 static void
-dec_5100_intr(status, cause, pc, ipending)
-	unsigned status;
-	unsigned cause;
-	unsigned pc;
-	unsigned ipending;
-{
-	u_int32_t icsr;
+dec_5100_intr(uint32_t status, vaddr_t pc, uint32_t ipending)
+{
+	uint32_t icsr;
 
 	if (ipending & MIPS_INT_MASK_4) {
@@ -165,6 +162,5 @@
 	}
 
-	icsr = *(volatile u_int32_t *)MIPS_PHYS_TO_KSEG1(KN230_SYS_ICSR);
-
+	icsr = *(volatile uint32_t *)MIPS_PHYS_TO_KSEG1(KN230_SYS_ICSR);
 	/* handle clock interrupts ASAP */
 	if (ipending & MIPS_INT_MASK_2) {
@@ -177,11 +173,5 @@
 		hardclock(&cf);
 		pmax_clock_evcnt.ev_count++;
-
-		/* keep clock interrupts enabled when we return */
-		cause &= ~MIPS_INT_MASK_2;
-	}
-
-	/* If clock interrupts were enabled, re-enable them ASAP. */
-	_splset(MIPS_SR_INT_IE | (status & MIPS_INT_MASK_2));
+	}
 
 	if (ipending & MIPS_INT_MASK_0) {
@@ -200,6 +190,4 @@
 		pmax_memerr_evcnt.ev_count++;
 	}
-
-	_splset(MIPS_SR_INT_IE | (status & ~cause & MIPS_HARD_INT_MASK));
 }
 
@@ -215,10 +203,10 @@
 dec_5100_memintr()
 {
-	u_int32_t icsr;
+	uint32_t icsr;
 
 	/* read icsr and clear error  */
-	icsr = *(volatile u_int32_t *)MIPS_PHYS_TO_KSEG1(KN230_SYS_ICSR);
+	icsr = *(volatile uint32_t *)MIPS_PHYS_TO_KSEG1(KN230_SYS_ICSR);
 	icsr |= KN230_CSR_INTR_WMERR;
-	*(volatile u_int32_t *)MIPS_PHYS_TO_KSEG1(KN230_SYS_ICSR) = icsr;
+	*(volatile uint32_t *)MIPS_PHYS_TO_KSEG1(KN230_SYS_ICSR) = icsr;
 	kn230_wbflush();
 
Index: /trunk/src/sys/arch/pmax/pmax/dec_maxine.c
===================================================================
--- /trunk/src/sys/arch/pmax/pmax/dec_maxine.c	(revision 151)
+++ /trunk/src/sys/arch/pmax/pmax/dec_maxine.c	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: dec_maxine.c,v 1.52.28.2 2010/02/01 06:09:21 matt Exp $ */
+/* $NetBSD: dec_maxine.c,v 1.52.28.4 2010/12/29 00:20:37 matt Exp $ */
 
 /*
@@ -105,7 +105,8 @@
  */
 
+#define __INTR_PRIVATE
 #include <sys/cdefs.h>			/* RCS ID & Copyright macro defns */
 
-__KERNEL_RCSID(0, "$NetBSD: dec_maxine.c,v 1.52.28.2 2010/02/01 06:09:21 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: dec_maxine.c,v 1.52.28.4 2010/12/29 00:20:37 matt Exp $");
 
 #include <sys/param.h>
@@ -113,6 +114,7 @@
 #include <sys/device.h>
 #include <sys/timetc.h>
-
-#include <machine/cpu.h>
+#include <sys/lwp.h>
+#include <sys/cpu.h>
+
 #include <machine/sysconf.h>
 #include <mips/mips/mips_mcclock.h>
@@ -132,14 +134,14 @@
 #include "xcfb.h"
 
-void		dec_maxine_init __P((void));		/* XXX */
-static void	dec_maxine_bus_reset __P((void));
-static void	dec_maxine_cons_init __P((void));
-static void	dec_maxine_intr __P((unsigned, unsigned, unsigned, unsigned));
-static void	dec_maxine_intr_establish __P((struct device *, void *,
-		    int, int (*)(void *), void *));
+void		dec_maxine_init(void);		/* XXX */
+static void	dec_maxine_bus_reset(void);
+static void	dec_maxine_cons_init(void);
+static void	dec_maxine_intr(uint32_t, vaddr_t, uint32_t);
+static void	dec_maxine_intr_establish(struct device *, void *,
+		    int, int (*)(void *), void *);
 
 static void	dec_maxine_tc_init(void);
 
-static void	kn02ca_wbflush __P((void));
+static void	kn02ca_wbflush(void);
 
 /*
@@ -148,8 +150,9 @@
 static uint32_t xine_tc3_imask;
 
-static const int dec_maxine_ipl2spl_table[] = {
-	[IPL_NONE] = 0,
-	[IPL_SOFTCLOCK] = _SPL_SOFTCLOCK,
-	[IPL_SOFTNET] = _SPL_SOFTNET,
+static const struct ipl_sr_map dec_maxine_ipl_sr_map = {
+    .sr_bits = {
+	[IPL_NONE] =		0,
+	[IPL_SOFTCLOCK] =	MIPS_SOFT_INT_MASK_0,
+	[IPL_SOFTNET] =		MIPS_SOFT_INT_MASK,
 	/*
 	 * MAXINE IOASIC interrupts come through INT 3, while
@@ -157,7 +160,9 @@
 	 * should block IOASIC activities.
 	 */
-	[IPL_VM] = MIPS_SPL3,
-	[IPL_SCHED] = MIPS_SPL_0_1_3,
-	[IPL_HIGH] = MIPS_SPL_0_1_3,
+	[IPL_VM] =		MIPS_SOFT_INT_MASK | MIPS_INT_MASK_3,
+	[IPL_SCHED] =		MIPS_INT_MASK,
+	[IPL_DDB] =		MIPS_INT_MASK,
+	[IPL_HIGH] =		MIPS_INT_MASK,
+    },
 };
 
@@ -180,5 +185,5 @@
 	ioasic_base = MIPS_PHYS_TO_KSEG1(XINE_SYS_ASIC);
 
-	ipl2spl_table = dec_maxine_ipl2spl_table;
+	ipl_sr_map = dec_maxine_ipl_sr_map;
  
 	/* calibrate cpu_mhz value */  
@@ -257,10 +262,6 @@
 
 static void
-dec_maxine_intr_establish(dev, cookie, level, handler, arg)
-	struct device *dev;
-	void *cookie;
-	int level;
-	int (*handler) __P((void *));
-	void *arg;
+dec_maxine_intr_establish(device_t dev, void *cookie, int level,
+	int (*handler)(void *), void *arg)
 {
 	unsigned mask;
@@ -311,5 +312,5 @@
     do {							\
 	if (can_serve & (bits)) {				\
-		ifound = 1;					\
+		ifound = true;					\
 		intrtab[vvv].ih_count.ev_count++;		\
 		(*intrtab[vvv].ih_func)(intrtab[vvv].ih_arg);	\
@@ -318,50 +319,25 @@
 
 static void
-dec_maxine_intr(status, cause, pc, ipending)
-	unsigned ipending;
-	unsigned pc;
-	unsigned status;
-	unsigned cause;
-{
-	if (ipending & MIPS_INT_MASK_4)
-		prom_haltbutton();
-
-	/* handle clock interrupts ASAP */
-	if (ipending & MIPS_INT_MASK_1) {
-		struct clockframe cf;
-
-		__asm volatile("lbu $0,48(%0)" ::
-			"r"(ioasic_base + IOASIC_SLOT_8_START));
-		cf.pc = pc;
-		cf.sr = status;
-		hardclock(&cf);
-		pmax_clock_evcnt.ev_count++;
-		/* keep clock interrupts enabled when we return */
-		cause &= ~MIPS_INT_MASK_1;
-	}
-
-	/* If clock interrupts were enabled, re-enable them ASAP. */
-	_splset(MIPS_SR_INT_IE | (status & MIPS_INT_MASK_1));
-
-	if (ipending & MIPS_INT_MASK_3) {
-		int ifound;
-		uint32_t imsk, intr, can_serve, xxxintr;
-
-		do {
-			ifound = 0;
-			intr = *(uint32_t *)(ioasic_base + IOASIC_INTR);
-			imsk = *(uint32_t *)(ioasic_base + IOASIC_IMSK);
-			can_serve = intr & imsk;
-
-			CHECKINTR(SYS_DEV_DTOP, XINE_INTR_DTOP);
-			CHECKINTR(SYS_DEV_SCC0, IOASIC_INTR_SCC_0);
-			CHECKINTR(SYS_DEV_LANCE, IOASIC_INTR_LANCE);
-			CHECKINTR(SYS_DEV_SCSI, IOASIC_INTR_SCSI);
-			/* CHECKINTR(SYS_DEV_OPT2, XINE_INTR_VINT);	*/
-			CHECKINTR(SYS_DEV_ISDN, (IOASIC_INTR_ISDN_TXLOAD | IOASIC_INTR_ISDN_RXLOAD));
-			/* CHECKINTR(SYS_DEV_FDC, IOASIC_INTR_FDC);	*/
-			CHECKINTR(SYS_DEV_OPT1, XINE_INTR_TC_1);
-			CHECKINTR(SYS_DEV_OPT0, XINE_INTR_TC_0);
- 
+dec_maxine_ioasic_intr(void)
+{
+	bool ifound;
+	uint32_t imsk, intr, can_serve, xxxintr;
+
+	do {
+		ifound = false;
+		intr = *(uint32_t *)(ioasic_base + IOASIC_INTR);
+		imsk = *(uint32_t *)(ioasic_base + IOASIC_IMSK);
+		can_serve = intr & imsk;
+
+		CHECKINTR(SYS_DEV_DTOP, XINE_INTR_DTOP);
+		CHECKINTR(SYS_DEV_SCC0, IOASIC_INTR_SCC_0);
+		CHECKINTR(SYS_DEV_LANCE, IOASIC_INTR_LANCE);
+		CHECKINTR(SYS_DEV_SCSI, IOASIC_INTR_SCSI);
+		/* CHECKINTR(SYS_DEV_OPT2, XINE_INTR_VINT);	*/
+		CHECKINTR(SYS_DEV_ISDN, (IOASIC_INTR_ISDN_TXLOAD | IOASIC_INTR_ISDN_RXLOAD));
+		/* CHECKINTR(SYS_DEV_FDC, IOASIC_INTR_FDC);	*/
+		CHECKINTR(SYS_DEV_OPT1, XINE_INTR_TC_1);
+		CHECKINTR(SYS_DEV_OPT0, XINE_INTR_TC_0);
+	 
 #define ERRORS	(IOASIC_INTR_ISDN_OVRUN|IOASIC_INTR_SCSI_OVRUN|IOASIC_INTR_SCSI_READ_E|IOASIC_INTR_LANCE_READ_E)
 #define PTRLOAD (IOASIC_INTR_ISDN_TXLOAD|IOASIC_INTR_ISDN_RXLOAD|IOASIC_INTR_SCSI_PTR_LOAD)
@@ -384,11 +360,34 @@
 	 * non-DMA interrupts from ioctl devices or TC options.
 	 */
-			xxxintr = can_serve & (ERRORS | PTRLOAD);
-			if (xxxintr) {
-				ifound = 1;
-				*(uint32_t *)(ioasic_base + IOASIC_INTR)
-					= intr &~ xxxintr;
-			}
-		} while (ifound);
+		xxxintr = can_serve & (ERRORS | PTRLOAD);
+		if (xxxintr) {
+			ifound = true;
+			*(uint32_t *)(ioasic_base + IOASIC_INTR)
+				= intr &~ xxxintr;
+		}
+	} while (ifound);
+}
+
+static void
+dec_maxine_intr(uint32_t status, vaddr_t pc, uint32_t ipending)
+{
+	if (ipending & MIPS_INT_MASK_4)
+		prom_haltbutton();
+
+	/* handle clock interrupts ASAP */
+	if (ipending & MIPS_INT_MASK_1) {
+		struct clockframe cf;
+
+		__asm volatile("lbu $0,48(%0)" ::
+			"r"(ioasic_base + IOASIC_SLOT_8_START));
+		cf.pc = pc;
+		cf.sr = status;
+		cf.intr = (curcpu()->ci_idepth > 1);
+		hardclock(&cf);
+		pmax_clock_evcnt.ev_count++;
+	}
+
+	if (ipending & MIPS_INT_MASK_3) {
+		dec_maxine_ioasic_intr();
 	}
 	if (ipending & MIPS_INT_MASK_2) {
@@ -396,6 +395,4 @@
 		pmax_memerr_evcnt.ev_count++;
 	}
-
-	_splset(MIPS_SR_INT_IE | (status & ~cause & MIPS_HARD_INT_MASK));
 }
 
@@ -403,5 +400,5 @@
 kn02ca_wbflush()
 {
-	/* read once IOASIC_IMSK */
+/* read once IOASIC_IMSK */
 	__asm volatile("lw $0,%0" ::
 	    "i"(MIPS_PHYS_TO_KSEG1(XINE_REG_IMSK)));
Index: /trunk/src/sys/arch/pmax/pmax/disksubr.c
===================================================================
--- /trunk/src/sys/arch/pmax/pmax/disksubr.c	(revision 151)
+++ /trunk/src/sys/arch/pmax/pmax/disksubr.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: disksubr.c,v 1.48 2008/01/02 11:48:27 ad Exp $	*/
+/*	$NetBSD: disksubr.c,v 1.48.24.1 2010/12/24 07:23:42 matt Exp $	*/
 
 /*
@@ -33,5 +33,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: disksubr.c,v 1.48 2008/01/02 11:48:27 ad Exp $");
+__KERNEL_RCSID(0, "$NetBSD: disksubr.c,v 1.48.24.1 2010/12/24 07:23:42 matt Exp $");
 
 #include "opt_compat_ultrix.h"
@@ -48,6 +48,6 @@
 #include <ufs/ffs/fs.h>			/* XXX for BBSIZE & SBSIZE */
 
-const char *compat_label __P((dev_t dev, void (*strat) __P((struct buf *bp)),
-	struct disklabel *lp, struct cpu_disklabel *osdep));	/* XXX */
+const char *compat_label(dev_t dev, void (*strat)(struct buf *bp),
+	struct disklabel *lp, struct cpu_disklabel *osdep);	/* XXX */
 
 #endif
Index: /trunk/src/sys/arch/pmax/pmax/interrupt.c
===================================================================
--- /trunk/src/sys/arch/pmax/pmax/interrupt.c	(revision 151)
+++ /trunk/src/sys/arch/pmax/pmax/interrupt.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: interrupt.c,v 1.15.18.2 2010/02/05 07:39:53 matt Exp $	*/
+/*	$NetBSD: interrupt.c,v 1.15.18.4 2010/12/29 08:18:29 matt Exp $	*/
 
 /*-
@@ -31,5 +31,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: interrupt.c,v 1.15.18.2 2010/02/05 07:39:53 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: interrupt.c,v 1.15.18.4 2010/12/29 08:18:29 matt Exp $");
 
 #include <sys/param.h>
@@ -41,4 +41,6 @@
 
 #include <mips/psl.h>
+#include <mips/locore.h>
+#include <mips/regnum.h>
 
 #include <machine/autoconf.h>
@@ -48,10 +50,13 @@
 struct evcnt pmax_clock_evcnt =
     EVCNT_INITIALIZER(EVCNT_TYPE_INTR, NULL, "clock", "intr");
+EVCNT_ATTACH_STATIC(pmax_clock_evcnt);
+#ifndef NOFPU
 struct evcnt pmax_fpu_evcnt =
     EVCNT_INITIALIZER(EVCNT_TYPE_INTR, NULL, "fpu", "intr");
+EVCNT_ATTACH_STATIC(pmax_fpu_evcnt);
+#endif
 struct evcnt pmax_memerr_evcnt =
     EVCNT_INITIALIZER(EVCNT_TYPE_INTR, NULL, "memerr", "intr");
-
-void MachFPInterrupt(unsigned, unsigned, unsigned, struct trapframe *);
+EVCNT_ATTACH_STATIC(pmax_memerr_evcnt);
 
 static const char * const intrnames[] = {
@@ -82,47 +87,28 @@
  */
 void
-cpu_intr(uint32_t status, uint32_t cause, uint32_t pc, uint32_t ipending)
+cpu_intr(int ppl, vaddr_t pc, uint32_t status)
 {
-	struct cpu_info *ci;
+	int ipl;
+	uint32_t pending;
 
-	ci = curcpu();
-	ci->ci_idepth++;
 	uvmexp.intrs++;
 
-	/* device interrupts */
-	if (ipending & (MIPS_INT_MASK_0|MIPS_INT_MASK_1|MIPS_INT_MASK_2|
-			MIPS_INT_MASK_3|MIPS_INT_MASK_4)) {
-		(*platform.iointr)(status, cause, pc, ipending);
+	while (ppl < (ipl = splintr(&pending))) {
+		/* device interrupts */
+		if (pending & (MIPS_INT_MASK_0|MIPS_INT_MASK_1|MIPS_INT_MASK_2|
+				MIPS_INT_MASK_3|MIPS_INT_MASK_4)) {
+			(*platform.iointr)(status, pc, pending);
+		}
+#if !defined(NOFPU)
+		/* FPU notification */
+		if (pending & MIPS_INT_MASK_5) {
+			if (!USERMODE(status))
+				panic("kernel used FPU: "
+				    "PC %#"PRIxVADDR", SR %#x", pc, status);
+
+			pmax_fpu_evcnt.ev_count++;
+			mips_fpu_intr(pc, curlwp->l_md.md_utf);
+		}
+#endif
 	}
-#if !defined(NOFPU)
-	/* FPU notification */
-	if (ipending & MIPS_INT_MASK_5) {
-		if (!USERMODE(status))
-			goto kerneltouchedFPU;
-		pmax_fpu_evcnt.ev_count++;
-		MachFPInterrupt(status, cause, pc, curlwp->l_md.md_utf);
-	}
-#endif
-
-	ci->ci_idepth--;
-
-#ifdef __HAVE_FAST_SOFTINTS
-	ipending &= MIPS_SOFT_INT_MASK;
-	if (ipending == 0)
-		return;
-	softint_process(ipending);
-#endif
-
-	return;
-kerneltouchedFPU:
-	panic("kernel used FPU: PC %x, CR %x, SR %x", pc, cause, status);
 }
-
-const int *ipl2spl_table;
-
-ipl_cookie_t
-makeiplcookie(ipl_t ipl)
-{
-
-	return (ipl_cookie_t){._spl = ipl2spl_table[ipl]};
-}
Index: /trunk/src/sys/arch/pmax/pmax/locore_machdep.S
===================================================================
--- /trunk/src/sys/arch/pmax/pmax/locore_machdep.S	(revision 151)
+++ /trunk/src/sys/arch/pmax/pmax/locore_machdep.S	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: locore_machdep.S,v 1.23 2005/12/11 12:18:39 christos Exp $	*/
+/*	$NetBSD: locore_machdep.S,v 1.23.96.1 2010/12/29 00:16:30 matt Exp $	*/
 
 /*
@@ -57,4 +57,5 @@
 #include <mips/cpuregs.h>	/* XXX - misnomer? */
 
+#include "assym.h"
 #include "sii.h"
 #include "opt_dec_5100.h"
@@ -163,2 +164,55 @@
 END(dec_mips1_wbflush)
 #endif	/* defined(DEC_5100) || defined(DEC_5400) */
+
+#ifdef __mips_o32
+NESTED(promcall, 0, ra)
+	sll	t9, a0, 0
+	sll	a0, a1, 0
+	sll	a1, a2, 0
+	sll	a2, a3, 0
+
+	j	t9
+	 nop
+END(promcall)
+#else
+NESTED(promcall, TF_SIZ, ra)
+	PTR_SUBU sp, TF_SIZ
+	REG_S	ra, TF_REG_RA(sp)
+	REG_S	s0, TF_REG_S0(sp)
+	REG_S	s1, TF_REG_S1(sp)
+	REG_S	s2, TF_REG_S2(sp)
+	REG_S	s3, TF_REG_S3(sp)
+	REG_S	s4, TF_REG_S4(sp)
+	REG_S	s5, TF_REG_S5(sp)
+	REG_S	s6, TF_REG_S6(sp)
+	REG_S	s7, TF_REG_S7(sp)
+	REG_S	s8, TF_REG_S8(sp)
+	REG_S	gp, TF_REG_GP(sp)
+
+	sll	t9, a0, 0
+	sll	a0, a1, 0
+	sll	a1, a2, 0
+	sll	a2, a3, 0
+
+	jal	t9
+	 nop
+
+	sll	v0, v0, 0
+
+	REG_L	ra, TF_REG_RA(sp)
+	REG_L	s0, TF_REG_S0(sp)
+	REG_L	s1, TF_REG_S1(sp)
+	REG_L	s2, TF_REG_S2(sp)
+	REG_L	s3, TF_REG_S3(sp)
+	REG_L	s4, TF_REG_S4(sp)
+	REG_L	s5, TF_REG_S5(sp)
+	REG_L	s6, TF_REG_S6(sp)
+	REG_L	s7, TF_REG_S7(sp)
+	REG_L	s8, TF_REG_S8(sp)
+	REG_L	gp, TF_REG_GP(sp)
+
+	PTR_ADDU sp, TF_SIZ
+	j	ra
+	nop
+END(promcall)
+#endif
Index: /trunk/src/sys/arch/pmax/pmax/machdep.c
===================================================================
--- /trunk/src/sys/arch/pmax/pmax/machdep.c	(revision 151)
+++ /trunk/src/sys/arch/pmax/pmax/machdep.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: machdep.c,v 1.223.8.1.2.7 2010/03/21 17:38:34 cliff Exp $	*/
+/*	$NetBSD: machdep.c,v 1.223.8.1.2.9 2010/12/29 00:22:01 matt Exp $	*/
 
 /*
@@ -78,5 +78,5 @@
 
 #include <sys/cdefs.h>			/* RCS ID & Copyright macro defns */
-__KERNEL_RCSID(0, "$NetBSD: machdep.c,v 1.223.8.1.2.7 2010/03/21 17:38:34 cliff Exp $");
+__KERNEL_RCSID(0, "$NetBSD: machdep.c,v 1.223.8.1.2.9 2010/12/29 00:22:01 matt Exp $");
 
 #include "fs_mfs.h"
@@ -162,11 +162,11 @@
 
 /* Motherboard or system-specific initialization vector */
-static void	unimpl_bus_reset __P((void));
-static void	unimpl_cons_init __P((void));
-static void	unimpl_iointr __P((unsigned, unsigned, unsigned, unsigned));
-static void	unimpl_intr_establish __P((struct device *, void *, int,
-		    int (*)(void *), void *));
-static int	unimpl_memsize __P((void *));
-static unsigned	nullwork __P((void));
+static void	unimpl_bus_reset(void);
+static void	unimpl_cons_init(void);
+static void	unimpl_iointr(uint32_t, vaddr_t, uint32_t);
+static void	unimpl_intr_establish(device_t, void *, int,
+		    int (*)(void *), void *);
+static int	unimpl_memsize(void *);
+static unsigned	nullwork(void);
 
 struct platform platform = {
@@ -267,5 +267,4 @@
 		callv = &callvec;
 	}
-	callv = (code == DEC_PROM_MAGIC) ? (void *)cv : &callvec;
 
 	/* Use PROM console output until we initialize a console driver. */
@@ -429,5 +428,5 @@
 
 void
-consinit()
+consinit(void)
 {
 
@@ -440,5 +439,5 @@
  */
 void
-cpu_startup()
+cpu_startup(void)
 {
 	vaddr_t minaddr, maxaddr;
@@ -484,6 +483,5 @@
  */
 void *
-lookup_bootinfo(type)
-	int type;
+lookup_bootinfo(int type)
 {
 	struct btinfo_common *bt;
@@ -506,7 +504,5 @@
 
 void
-cpu_reboot(howto, bootstr)
-	volatile int howto;	/* XXX volatile to keep gcc happy */
-	char *bootstr;
+cpu_reboot(int howto, char *bootstr)
 {
 
@@ -570,6 +566,5 @@
  */
 int
-memsize_scan(first)
-	void *first;
+memsize_scan(void *first)
 {
 	int i, mem;
@@ -616,6 +611,5 @@
  */
 int
-memsize_bitmap(first)
-	void *first;
+memsize_bitmap(void *first)
 {
 	memmap *prom_memmap = (memmap *)first;
@@ -657,5 +651,5 @@
  */
 static void
-unimpl_bus_reset()
+unimpl_bus_reset(void)
 {
 
@@ -664,5 +658,5 @@
 
 static void
-unimpl_cons_init()
+unimpl_cons_init(void)
 {
 
@@ -671,9 +665,5 @@
 
 static void
-unimpl_iointr(mask, pc, statusreg, causereg)
-	u_int mask;
-	u_int pc;
-	u_int statusreg;
-	u_int causereg;
+unimpl_iointr(uint32_t status, vaddr_t pc, uint32_t ipending)
 {
 
@@ -682,10 +672,6 @@
 
 static void
-unimpl_intr_establish(dev, cookie, level, handler, arg)
-	struct device *dev;
-	void *cookie;
-	int level;
-	int (*handler) __P((void *));
-	void *arg;
+unimpl_intr_establish(device_t dev, void *cookie, int level,
+	int (*handler)(void *), void *arg)
 {
 	panic("sysconf.init didn't set intr_establish");
@@ -693,6 +679,5 @@
 
 static int
-unimpl_memsize(first)
-void *first;
+unimpl_memsize(void *first)
 {
 
@@ -701,5 +686,5 @@
 
 static unsigned
-nullwork()
+nullwork(void)
 {
 
@@ -711,6 +696,5 @@
  */
 void
-delay(n)
-        int n;
+delay(int n)
 {
 
Index: /trunk/src/sys/arch/pmax/pmax/promcall.c
===================================================================
--- /trunk/src/sys/arch/pmax/pmax/promcall.c	(revision 151)
+++ /trunk/src/sys/arch/pmax/pmax/promcall.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: promcall.c,v 1.12.76.1 2009/09/16 19:23:18 matt Exp $	*/
+/*	$NetBSD: promcall.c,v 1.12.76.3 2010/12/29 00:16:30 matt Exp $	*/
 
 /*
@@ -78,5 +78,5 @@
 
 #include <sys/cdefs.h>			/* RCS ID & Copyright macro defns */
-__KERNEL_RCSID(0, "$NetBSD: promcall.c,v 1.12.76.1 2009/09/16 19:23:18 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: promcall.c,v 1.12.76.3 2010/12/29 00:16:30 matt Exp $");
 
 #include <sys/param.h>
@@ -120,5 +120,5 @@
 
 	s  = splhigh();
-	chr = (*callv->_getchar)();
+	chr = promcall(callv->_getchar);
 	splx(s);
 	return chr;
@@ -134,5 +134,5 @@
 
 	s = splhigh();
-	(*callv->_printf)("%c", c);
+	promcall(callv->_printf, "%c", c);
 	splx(s);
 }
@@ -195,5 +195,5 @@
 prom_getenv(const char *name)
 {
-	return (*callv->_getenv)(name);
+	return (void *)promcall(callv->_getenv, name);
 }
 
@@ -208,10 +208,14 @@
 prom_systype(void)
 {
+#ifndef _LP64
 	char *cp;
 
 	if (callv != &callvec)
-		return (*callv->_getsysid)();
+#endif
+		return promcall(callv->_getsysid);
+#ifndef _LP64
 	cp = prom_getenv("systype");
 	return (cp != NULL) ? strtoul(cp, NULL, 0) : 0;
+#endif
 }
 
@@ -222,5 +226,5 @@
 prom_haltbutton(void)
 {
-	(*callv->_halt)((int *)0, 0);
+	promcall(callv->_halt, (int *)0, 0);
 }
 
@@ -232,7 +236,7 @@
 {
 	if (callv != &callvec)
-		(*callv->_rex)((howto & RB_HALT) ? 'h' : 'b');
+		promcall(callv->_rex, (howto & RB_HALT) ? 'h' : 'b');
 	else {
-		void __dead (*f) __P((void));
+		void __dead (*f)(void);
 
 		f = (howto & RB_HALT)
@@ -270,5 +274,5 @@
 
 	if (callv->_getbitmap != NULL)
-		return (callv->_getbitmap(map));
+		return promcall(callv->_getbitmap, map);
 	/*
 	 * See if we can get the bitmap from the environment variables
Index: /trunk/src/sys/arch/pmax/pmax/sysconf.c
===================================================================
--- /trunk/src/sys/arch/pmax/pmax/sysconf.c	(revision 151)
+++ /trunk/src/sys/arch/pmax/pmax/sysconf.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: sysconf.c,v 1.10 2005/12/11 12:18:39 christos Exp $	*/
+/*	$NetBSD: sysconf.c,v 1.10.96.1 2010/12/24 07:23:42 matt Exp $	*/
 
 /*
@@ -32,5 +32,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: sysconf.c,v 1.10 2005/12/11 12:18:39 christos Exp $");
+__KERNEL_RCSID(0, "$NetBSD: sysconf.c,v 1.10.96.1 2010/12/24 07:23:42 matt Exp $");
 
 #include <sys/param.h>
@@ -42,5 +42,5 @@
 #include "opt_dec_3100.h"
 #ifdef DEC_3100
-  void	dec_3100_init __P((void));
+  void	dec_3100_init(void);
 #else
 # define dec_3100_init		platform_not_configured
@@ -49,5 +49,5 @@
 #include "opt_dec_3max.h"
 #ifdef DEC_3MAX
-  void	dec_3max_init __P((void));
+  void	dec_3max_init(void);
 #else
 # define dec_3max_init	platform_not_configured
@@ -57,5 +57,5 @@
 #include "opt_dec_3min.h"
 #ifdef DEC_3MIN
-  void	dec_3min_init __P((void));
+  void	dec_3min_init(void);
 #else
 # define dec_3min_init	platform_not_configured
@@ -65,5 +65,5 @@
 #include "opt_dec_maxine.h"
 #ifdef DEC_MAXINE
-  void	dec_maxine_init __P((void));
+  void	dec_maxine_init(void);
 #else
 # define dec_maxine_init	platform_not_configured
@@ -72,5 +72,5 @@
 #include "opt_dec_3maxplus.h"
 #ifdef DEC_3MAXPLUS
-  void	dec_3maxplus_init __P((void));
+  void	dec_3maxplus_init(void);
 #else
 # define dec_3maxplus_init	platform_not_configured
@@ -79,5 +79,5 @@
 #include "opt_dec_5100.h"
 #ifdef DEC_5100
-  void	dec_5100_init __P((void));
+  void	dec_5100_init(void);
 #else
 # define dec_5100_init	platform_not_configured
@@ -86,5 +86,5 @@
 #include "opt_dec_5400.h"
 #ifdef DEC_5400
-  void	dec_5400_init __P((void));
+  void	dec_5400_init(void);
 #else
 # define dec_5400_init	platform_not_configured
@@ -93,5 +93,5 @@
 #include "opt_dec_5500.h"
 #ifdef DEC_5500
-  void	dec_5500_init __P((void));
+  void	dec_5500_init(void);
 #else
 # define dec_5500_init	platform_not_configured
@@ -101,5 +101,5 @@
 #include "opt_dec_5800.h"
 #ifdef DEC_5800
-  void	dec_5800_init __P((void));
+  void	dec_5800_init(void);
 #else
 # define dec_5800_init	platform_not_configured
@@ -107,5 +107,5 @@
 
 
-struct sysinit sysinit[] = {
+const struct sysinit sysinit[] = {
 	sys_notsupp("???"),			     /*	 0: ??? */
 	sys_init(dec_3100_init,"DEC_3100"),	     /*	 1: PMAX */
@@ -122,5 +122,5 @@
 	sys_init(dec_5100_init,"DEC_5100"),	     /*	 12: 5100 */
 };
-int nsysinit = (sizeof(sysinit) / sizeof(sysinit[0]));
+const int nsysinit = __arraycount(sysinit);
 
 
Index: /trunk/src/sys/arch/pmax/tc/tcbus.c
===================================================================
--- /trunk/src/sys/arch/pmax/tc/tcbus.c	(revision 151)
+++ /trunk/src/sys/arch/pmax/tc/tcbus.c	(revision 152)
@@ -1,3 +1,3 @@
-/*	$NetBSD: tcbus.c,v 1.21 2008/05/26 10:31:22 nisimura Exp $	*/
+/*	$NetBSD: tcbus.c,v 1.21.16.1 2010/12/29 00:16:30 matt Exp $	*/
 
 /*-
@@ -31,5 +31,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: tcbus.c,v 1.21 2008/05/26 10:31:22 nisimura Exp $");
+__KERNEL_RCSID(0, "$NetBSD: tcbus.c,v 1.21.16.1 2010/12/29 00:16:30 matt Exp $");
 
 /*
@@ -193,5 +193,5 @@
 #include <machine/dec_prom.h>
 
-int	tc_checkslot __P((tc_addr_t, char *));
+int	tc_checkslot(tc_addr_t, char *);
 
 struct cnboards {
@@ -230,6 +230,5 @@
 
 int
-tcfb_cnattach(slotno)
-	int slotno;
+tcfb_cnattach(int slotno)
 {
 	paddr_t tcaddr;
@@ -237,13 +236,14 @@
 	int i;
 
-	tcaddr = (*callv->_slot_address)(slotno);
+	tcaddr = promcall(callv->_slot_address, slotno);
 	if (tc_badaddr(tcaddr) || tc_checkslot(tcaddr, tcname) == 0)
 		panic("TC console designated by PROM does not exist!?");
 
-	for (i = 0; i < sizeof(cnboards) / sizeof(cnboards[0]); i++)
+	for (i = 0; i < __arraycount(cnboards); i++) {
 		if (strncmp(tcname, cnboards[i].cb_tcname, TC_ROM_LLEN) == 0)
 			break;
-
-	if (i == sizeof(cnboards) / sizeof(cnboards[0]))
+	}
+
+	if (i == __arraycount(cnboards))
 		return (0);
 
Index: /trunk/src/sys/arch/powerpc/tools/chrpicon/Makefile
===================================================================
--- /trunk/src/sys/arch/powerpc/tools/chrpicon/Makefile	(revision 151)
+++ /trunk/src/sys/arch/powerpc/tools/chrpicon/Makefile	(revision 152)
@@ -1,3 +1,3 @@
-#	$NetBSD: Makefile,v 1.1 1999/11/19 00:43:20 lonhyn Exp $
+#	$NetBSD: Makefile,v 1.1.1.1 1999/11/19 00:43:20 lonhyn Exp $
 
 SUBDIR= chrpicontoppm ppmtochrpicon
Index: /trunk/src/sys/arch/powerpc/tools/chrpicon/README
===================================================================
--- /trunk/src/sys/arch/powerpc/tools/chrpicon/README	(revision 151)
+++ /trunk/src/sys/arch/powerpc/tools/chrpicon/README	(revision 152)
@@ -1,4 +1,4 @@
 
-$NetBSD: README,v 1.1 1999/11/19 00:43:20 lonhyn Exp $
+$NetBSD: README,v 1.1.1.1 1999/11/19 00:43:20 lonhyn Exp $
 
 Routines for converting back and forth between CHRP boot icons
Index: /trunk/src/sys/arch/sbmips/conf/GENERIC
===================================================================
--- /trunk/src/sys/arch/sbmips/conf/GENERIC	(revision 151)
+++ /trunk/src/sys/arch/sbmips/conf/GENERIC	(revision 152)
@@ -1,3 +1,3 @@
-# $NetBSD: GENERIC,v 1.70.8.5 2010/05/14 23:16:08 cliff Exp $
+# $NetBSD: GENERIC,v 1.70.8.6 2011/04/29 09:21:46 matt Exp $
 
 include 	"arch/sbmips/conf/std.sbmips"
@@ -5,5 +5,5 @@
 options 	INCLUDE_CONFIG_FILE	# embed config file in kernel binary
 
-#ident 		"GENERIC-$Revision: 1.70.8.5 $"
+#ident 		"GENERIC-$Revision: 1.70.8.6 $"
 
 #options 	LOCKDEBUG	# XXX XXX XXX XXX
@@ -36,5 +36,5 @@
 options 	DDB_HISTORY_SIZE=100 # enable history editing in DDB
 makeoptions 	DEBUG="-g"	# compile full symbol table
-options 	SYMTAB_SPACE=380000	# size for embedded symbol table
+options 	SYMTAB_SPACE=400000	# size for embedded symbol table
 
 # Compatibility options
Index: /trunk/src/sys/arch/sbmips/include/cpuvar.h
===================================================================
--- /trunk/src/sys/arch/sbmips/include/cpuvar.h	(revision 151)
+++ /trunk/src/sys/arch/sbmips/include/cpuvar.h	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: cpuvar.h,v 1.1.2.1 2010/03/11 22:26:56 matt Exp $ */
+/* $NetBSD: cpuvar.h,v 1.1.2.2 2010/12/29 08:19:58 matt Exp $ */
 
 #ifndef _SBMIPS_CPUVAR_H_
@@ -13,4 +13,7 @@
 	uint64_t sb1cpu_imr_all;
 	struct evcnt sb1cpu_intr_evcnts[64];
+	struct evcnt sb1cpu_spurious_intrs[_IPL_N];
+	struct evcnt sb1cpu_intrs[_IPL_N];
+	struct evcnt sb1cpu_int5;
 };
 #endif /* _LOCORE */
Index: /trunk/src/sys/arch/sbmips/include/systemsw.h
===================================================================
--- /trunk/src/sys/arch/sbmips/include/systemsw.h	(revision 151)
+++ /trunk/src/sys/arch/sbmips/include/systemsw.h	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: systemsw.h,v 1.7.28.5 2010/03/11 08:20:59 matt Exp $ */
+/* $NetBSD: systemsw.h,v 1.7.28.6 2010/06/10 17:40:20 cliff Exp $ */
 
 /*
@@ -59,4 +59,5 @@
 struct cpu_softc;
 void	sb1250_cpu_init(struct cpu_softc *);
+void	sb1250_ipl_map_init(void);
 
 #define	cpu_intr_establish(n,s,f,a)	((*systemsw.s_intr_establish)(n,s,f,a))
Index: /trunk/src/sys/arch/sbmips/sbmips/cpu.c
===================================================================
--- /trunk/src/sys/arch/sbmips/sbmips/cpu.c	(revision 151)
+++ /trunk/src/sys/arch/sbmips/sbmips/cpu.c	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: cpu.c,v 1.18.16.8 2010/05/11 21:08:51 matt Exp $ */
+/* $NetBSD: cpu.c,v 1.18.16.9 2010/09/01 01:07:26 matt Exp $ */
 
 /*
@@ -34,5 +34,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: cpu.c,v 1.18.16.8 2010/05/11 21:08:51 matt Exp $");
+__KERNEL_RCSID(0, "$NetBSD: cpu.c,v 1.18.16.9 2010/09/01 01:07:26 matt Exp $");
 
 #include "opt_multiprocessor.h"
@@ -135,5 +135,5 @@
 #if defined(MULTIPROCESSOR)
 		int status;
-		ci = cpu_info_alloc(NULL, found - 1);
+		ci = cpu_info_alloc(NULL, found - 1, 0, found - 1, 0);
 		KASSERT(ci);
 
Index: /trunk/src/sys/arch/sbmips/sbmips/machdep.c
===================================================================
--- /trunk/src/sys/arch/sbmips/sbmips/machdep.c	(revision 151)
+++ /trunk/src/sys/arch/sbmips/sbmips/machdep.c	(revision 152)
@@ -1,3 +1,3 @@
-/* $NetBSD: machdep.c,v 1.38.10.8 2010/03/21 17:38:35 cliff Exp $ */
+/* $NetBSD: machdep.c,v 1.38.10.10 2011/04/29 08:26:35 matt Exp $ */
 
 /*
@@ -59,5 +59,5 @@
 
 #include <sys/cdefs.h>
-__KERNEL_RCSID(0, "$NetBSD: machdep.c,v 1.38.10.8 2010/03/21 17:38:35 cliff Exp $");
+__KERNEL_RCSID(0, "$NetBSD: machdep.c,v 1.38.10.10 2011/04/29 08:26:35 matt Exp $");
 
 #include "opt_ddb.h"
@@ -102,4 +102,6 @@
 #include <machine/leds.h>
 
+#include <mips/sibyte/dev/sbbuswatchvar.h>
+
 #include "ksyms.h"
 
@@ -143,10 +145,4 @@
 void	configure(void);
 void	mach_init(long, long, long, long);
-
-/*
- * safepri is a safe priority for sleep to set for a spin-wait during
- * autoconfiguration or after a panic.  Used as an argument to splx().
- */
-int	safepri = MIPS_INT_MASK | MIPS_SR_INT_IE;
 
 extern void *esym;
@@ -218,5 +214,13 @@
 	 * Clear out the I and D caches.
 	 */
-	mips_vector_init(NULL);
+#ifdef MULTIPROCESSOR
+	mips_vector_init(NULL, true);
+#else
+	mips_vector_init(NULL, false);
+#endif
+
+	mips_locoresw.lsw_bus_error = sibyte_bus_watch_check;
+
+	sb1250_ipl_map_init();
 
 #ifdef DEBUG
@@ -370,5 +374,5 @@
 
 	/* Take a snapshot before clobbering any registers. */
-	savectx(curlwp->l_addr);
+	savectx(lwp_getpcb(curlwp));
 
 	if (cold) {
